/**********************************************************************
 *<
	FILE: ObjectDeform.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 2000, All Rights Reserved.
 **********************************************************************/

#include "ObjectDeform.h"




static ObjectDeformClassDesc ObjectDeformDesc;
ClassDesc2* GetObjectDeformDesc() { return &ObjectDeformDesc; }


enum { objectdeform_params };


//TODO: Add enums for various parameters
enum { 
	pb_standoff,
	pb_falloff,
	pb_quaddepth,
	pb_node,
	pb_curve,
	pb_invertcollision,
	pb_collisiontype,
	pb_affectmultipleframes,
	pb_startframe,
	pb_endframe,
	pb_quality
};



static ParamBlockDesc2 objectdeform_param_blk ( objectdeform_params, _T("params"),  0, &ObjectDeformDesc, 
	P_AUTO_CONSTRUCT + P_AUTO_UI, PBLOCK_REF, 
	//rollout
	IDD_PANEL, IDS_PARAMS, 0, 0, NULL,
	// params
	pb_standoff, 			_T("standoff"), 		TYPE_FLOAT, 	P_ANIMATABLE, 	IDS_STANDOFF, 
		p_default, 		0.0f, 
		p_range, 		-10000.0f,10000.0f, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_FLOAT, IDC_STANDOFF,	IDC_STANDOFF_SPIN, 0.1f, 
		end,
	pb_falloff, 			_T("falloff"), 		TYPE_FLOAT, 	P_ANIMATABLE, 	IDS_FALLOFF, 
		p_default, 		0.0f, 
		p_range, 		0.0f,1000.0f, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_FLOAT, IDC_FALLOFF,	IDC_FALLOFF_SPIN, 0.1f, 
		end,

	pb_quaddepth, 			_T("quadDepth"), 		TYPE_INT, 	0, 	IDS_QUADDEPTH, 
		p_default, 		5, 
		p_range, 		2,10, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_INT, IDC_QUAD,	IDC_QUAD_SPIN, 1.0f, 
		end,
		
	pb_node, 	_T("node"),		TYPE_INODE, 		0,				IDS_NODE,
		p_ui, 			TYPE_PICKNODEBUTTON, 	IDC_PICK_OBJECT, 
		end, 

	pb_invertcollision, 	_T("invertCollision"),		TYPE_BOOL,	P_RESET_DEFAULT,IDS_INVERT,
		p_default, 		FALSE, 
		p_ui, 			TYPE_SINGLECHEKBOX, 	IDC_INVERT_CHECK, 
		end, 

	pb_collisiontype,  _T("collisionType"), TYPE_INT, 	P_RESET_DEFAULT, 	IDS_TYPE, 
		p_default, 		0,	
		p_range, 		0, 1, 
		p_ui, 			TYPE_RADIO, 2,IDC_RADIO1,IDC_RADIO2,
		end, 

	pb_quality, 			_T("quality"), 		TYPE_INT, 	P_ANIMATABLE, 	IDS_QUALITY, 
		p_default, 		10, 
		p_range, 		2,40, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_INT, IDC_QUALITY,	IDC_QUALITY_SPIN, 1.0f, 
		end,

	pb_affectmultipleframes, 	_T("affectMultipleFrames"),		TYPE_BOOL,	P_RESET_DEFAULT,IDS_FRAMES,
		p_default, 		FALSE, 
		p_ui, 			TYPE_SINGLECHEKBOX, 	IDC_AFFECT_CHECK, 
		end, 
	pb_startframe, 			_T("startFrame"), 		TYPE_INT, 	0, 	IDS_STARTFRAME, 
		p_default, 		0, 
		p_range, 		-100000,1000000, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_INT, IDC_START,	IDC_START_SPIN, 1.0f, 
		end,

	pb_endframe, 			_T("endFrame"), 		TYPE_INT, 	0, 	IDS_ENDFRAME, 
		p_default, 		100, 
		p_range, 		-100000,1000000, 
		p_ui, 			TYPE_SPINNER,		EDITTYPE_INT, IDC_END,	IDC_END_SPIN, 1.0f, 
		end,


		

	end
	);




IObjParam *ObjectDeform::ip			= NULL;



BOOL ObjectDeformDlgProc::DlgProc(
		TimeValue t,IParamMap2 *map,HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
	{
	mod->rolluphWnd = hWnd;

	switch (msg) {
		case WM_INITDIALOG: 
			{
			mod->DisplayCacheMem();
			break;
			}

		case WM_COMMAND:
			switch (LOWORD(wParam)) 
				{
				case IDC_SOLVE:
					{
					mod->SolveFrames();
					break;
					}
				case IDC_CLEAR:
					{
					mod->ClearCache();
					break;
					}

				case IDC_HELPBUTTON:
					ShellExecute(GetCOREInterface()->GetMAXHWnd(), "open", "iexplore.exe", "www.max3dstuff.com/max4/objectDeform/help.html", NULL, SW_SHOWNORMAL);
					break;

				}
			
			break;
		}
	return FALSE;
	}


int MyEnumProc::proc(ReferenceMaker *rmaker) 
	{ 
	if (rmaker->ClassID()==Class_ID(0x5c2417bd, 0x44050964))    
		{
		IParamBlock *pb;
		pb = (IParamBlock *) rmaker->GetReference(4);
		Interval ivalid;
		int anioff;
		pb->GetValue(32,0,anioff,ivalid);
		if (anioff != 0)
			nukeME = TRUE;
		}
//7-1-99
	if (rmaker->SuperClassID()==BASENODE_CLASS_ID)    
		{
		Nodes.Append(1, (INode **)&rmaker);  
		count++;
		}
	if (rmaker->ClassID()==Class_ID(XREFOBJ_CLASS_ID,0))    
		{
		xRefFound = TRUE;
		}


	return 0;
	}	





//--- ObjectDeform -------------------------------------------------------
ObjectDeform::ObjectDeform()
{
	inSolve = FALSE;
	validator.mod = this;
	ObjectDeformDesc.MakeAutoParamBlocks(this);
}

ObjectDeform::~ObjectDeform()
{
}

/*===========================================================================*\
 |	The validity of the parameters.  First a test for editing is performed
 |  then Start at FOREVER, and intersect with the validity of each item
\*===========================================================================*/
Interval ObjectDeform::LocalValidity(TimeValue t)
{
	// if being edited, return NEVER forces a cache to be built 
	// after previous modifier.
	if (TestAFlag(A_MOD_BEING_EDITED))
		return NEVER;  
	//TODO: Return the validity interval of the modifier
	return ivalid;
}


/*************************************************************************************************
*
	Between NotifyPreCollapse and NotifyPostCollapse, Modify is
	called by the system.  NotifyPreCollapse can be used to save any plugin dependant data e.g.
	LocalModData
*
\*************************************************************************************************/

void ObjectDeform::NotifyPreCollapse(INode *node, IDerivedObject *derObj, int index)
{
	//TODO:  Perform any Pre Stack Collapse methods here
}



/*************************************************************************************************
*
	NotifyPostCollapse can be used to apply the modifier back onto to the stack, copying over the
	stored data from the temporary storage.  To reapply the modifier the following code can be 
	used

	Object *bo = node->GetObjectRef();
	IDerivedObject *derob = NULL;
	if(bo->SuperClassID() != GEN_DERIVOB_CLASS_ID)
	{
		derob = CreateDerivedObject(obj);
		node->SetObjectRef(derob);
	}
	else
		derob = (IDerivedObject*) bo;

	// Add ourselves to the top of the stack
	derob->AddModifier(this,NULL,derob->NumModifiers());

*
\*************************************************************************************************/

void ObjectDeform::NotifyPostCollapse(INode *node,Object *obj, IDerivedObject *derObj, int index)
{
	//TODO: Perform any Post Stack collapse methods here.

}


/*************************************************************************************************
*
	ModifyObject will do all the work in a full modifier
    This includes casting objects to their correct form, doing modifications
	changing their parameters, etc
*
\************************************************************************************************/


INode* ObjectDeform::GetNodeFromModContext(ModContext *smd, int &which)
	{

	int				i;
	SClass_ID		sc;
	IDerivedObject* dobj;

    MyEnumProc dep;              
	EnumDependents(&dep);
	for ( i = 0; i < dep.Nodes.Count(); i++)
		{
		INode *node = dep.Nodes[i];
		BOOL found = FALSE;

		Object* obj = node->GetObjectRef();
		int ct = 0;

		if ((sc = obj->SuperClassID()) == GEN_DERIVOB_CLASS_ID)
			{
			dobj = (IDerivedObject*)obj;
			while (sc == GEN_DERIVOB_CLASS_ID)
				{
				for (int j = 0; j < dobj->NumModifiers(); j++)
					{
					ModContext *mc = dobj->GetModContext(j);
					if (mc == smd)
						{
						return node;
						which = i;
						}

					}
				dobj = (IDerivedObject*)dobj->GetObjRef();
				sc = dobj->SuperClassID();

				}

			}
		}
	return NULL;
	}


ObjDeformer::ObjDeformer(ObjectDeform *m)
	{
	mod = m;
	}

Point3 ObjDeformer::Map(int i, Point3 p)
	{

	if ( (mod->fromCache) && (!mod->inSolve))
		{	
		int id = mod->redirList[i];
		if (id >=0)
			{
			if (mod->falloff  > 0.0f)
				{
				mod->distList[i] = 0.0f;
				mod->processList.Set(i);
				mod->vecList[i] = mod->frameData[mod->currentFrame]->points[id];
				}
			p += mod->frameData[mod->currentFrame]->points[id];
			}
		return p;
		}
//loop back duration
	Point3 op = p;

	int redirected=-1;
	if ((mod->currentFrame != 0) && (mod->inSolve))
		{
		
		int id = mod->redirList[i];
		redirected = id;
		if (id >=0)
			{
			p += mod->frameData[mod->currentFrame-1]->points[id];
			}
		}

//add vecs to point
	p = p * mod->objtm;
	BOOL hit = FALSE;
//see if hit object if so move the z
	if (mod->collisionType == 0)
		{
		float z;
		hit = mod->meshSearchTree.HitMesh(p, z);
		if (hit)
			{
			if (z > p.z)
				p.z = z + mod->standoff;
			}
		}
	else
		{
//check if inside if so move along normal til it is not
		Point3 norm;
		hit = mod->meshSearchTree.IsInsideMesh(p);
		if (hit)
			{
			
			norm = mod->baseVNorms[i].GetNormal(0xffffffff);
			norm = VectorTransform(mod->objtm,norm);
			if (mod->dent) norm *= -1.0f;
			Point3 addDist = norm * mod->normDist;


			int ct =0;
			Point3 insidePoint = p;
			Point3 outsidePoint;
			outsidePoint = p + addDist;

			BOOL wasInside = TRUE;
			BOOL done = FALSE;
			while ((!done) && (ct < mod->quality))
				{
//add norm to hit

//check if still inside
				Point3 mid = (insidePoint + outsidePoint) * 0.5f;
				if (mod->meshSearchTree.IsInsideMesh(mid))
					{
					insidePoint = mid;
					}
				else
//if not			
					{
					outsidePoint = mid;
					}
				if (LengthSquared(insidePoint-outsidePoint) < 0.0001f) done = TRUE;
				ct++;
				}
			p = outsidePoint + norm * mod->standoff;

			}

		}
	p = p * mod->invobjtm;
//if recording get new vec
	if ( (hit || (redirected != -1)) )
		{
		Point3 vec = p -op;

		if (mod->falloff  > 0.0f)
			{
			mod->distList[i] = 0.0f;
			mod->processList.Set(i);
			mod->vecList[i] = vec;
			}

		if (mod->inSolve)
			{
			mod->tempIndex[i] = i;
			mod->tempPoints[i] = vec;
			}
		}
	return p;
	}



void ObjectDeform::BuildNormals(Mesh *mesh)
{

	Face *face;	
	Point3 *verts;
	Point3 v0, v1, v2;


	face = mesh->faces;	
	verts = mesh->verts;
	baseVNorms.SetCount(mesh->getNumVerts());
	baseFNorms.SetCount(mesh->getNumFaces());

	// Compute face and vertex surface normals
	for (int i = 0; i < mesh->getNumVerts(); i++) 
		{
		baseVNorms[i] = VNormal();
		}
	for (i = 0; i < mesh->getNumFaces(); i++, face++) 
		{

// Calculate the surface normal
		v0 = verts[face->v[0]];
		v1 = verts[face->v[1]];
		v2 = verts[face->v[2]];
		baseFNorms[i] = (v1-v0)^(v2-v1);
		for (int j=0; j<3; j++) 
			{		
			baseVNorms[face->v[j]].AddNormal(baseFNorms[i],face->smGroup);
			}
		baseFNorms[i] = Normalize(baseFNorms[i]);
		}
	for (i=0; i < mesh->getNumVerts(); i++) 
		{
		baseVNorms[i].Normalize();
		}
}


void ObjectDeform::ModifyObject(TimeValue t, ModContext &mc, ObjectState * os, INode *node) 
{
	//TODO: Add the code for actually modifying the object

	//TODO: Add code to evaluate anything prior to rendering
	INode *targnode;
	ivalid = FOREVER;
	pblock->GetValue(pb_node,t,targnode,ivalid);

	pblock->GetValue(pb_standoff,t,standoff,ivalid);
	pblock->GetValue(pb_falloff,t,falloff,ivalid);
	pblock->GetValue(pb_quaddepth,t,quadDepth,ivalid);

	pblock->GetValue(pb_collisiontype,t,collisionType,ivalid);
	BOOL invert;
	pblock->GetValue(pb_invertcollision,t,invert,ivalid);

	pblock->GetValue(pb_startframe,t,startFrame,ivalid);
	pblock->GetValue(pb_endframe,t,endFrame,ivalid);

	pblock->GetValue(pb_quality,t,quality,ivalid);

	pblock->GetValue(pb_affectmultipleframes,t,fromCache,ivalid);

	BOOL deleteMesh = FALSE;
	TriObject *tobjDelete = NULL;

	Mesh *msh = NULL;
//only really need to update quad tree when the mesh geom changes

	if ((targnode == NULL) && (!fromCache)) return;


	Tab<int> connectedTo;
	Tab<float> edgeDists;
	if ( (falloff  > 0.0f) && (!inSolve) )
		{
		TriObject *baseTObj = (TriObject*)os->obj;
		Mesh &baseMesh = baseTObj->GetMesh();
//compute edge list
//create a dist table
		distList.SetCount(baseMesh.numVerts);
		vecList.SetCount(baseMesh.numVerts);
		connectedTo.SetCount(baseMesh.numVerts);
		for (int i =0; i < baseMesh.numVerts; i ++)
			{
			distList[i] = FLT_MAX;
			connectedTo[i] = -1;
			vecList[i] = Point3(0.0f,0.0f,0.0f);
			}
//build a processed bitarray list
		processList.SetSize(baseMesh.numVerts);
		processList.ClearAll();

		AdjEdgeList adjEdges(baseMesh);
//repeat until all verties are gone
		edgeDists.SetCount(adjEdges.edges.Count());
		for (i=0; i < adjEdges.edges.Count(); i++)
			{
			int a,b;
			a = adjEdges.edges[i].v[0];
			b = adjEdges.edges[i].v[1];
			float dist = Length(baseMesh.verts[a] - baseMesh.verts[b]);
			edgeDists[i] = dist;

			}

		}

	if ((targnode != NULL) && (inSolve || !fromCache))
		{
//get the mesh for this node
		if (collisionType == 1)
			{
			TriObject *baseTObj = (TriObject*)os->obj;
			Mesh &baseMesh = baseTObj->GetMesh();
//compute the normals
			BuildNormals(&baseMesh);
//transform the mesh norms into our hit space
			meshSearchTree.InvertNorms(TRUE);
			baseMesh.buildBoundingBox();
			Box3 bb = baseMesh.getBoundingBox();
			normDist = Length(bb.pmax-bb.pmin);
			normDist *= 1.1f;
			if (invert) dent = TRUE;
			else dent = FALSE;

			}
		else meshSearchTree.InvertNorms(FALSE);
		

		objtm = Inverse(targnode->GetObjectTM(t,&ivalid));
		INode *baseNode;
		int blank;
		baseNode = GetNodeFromModContext(&mc, blank);
		Matrix3 baseTM = baseNode->GetObjectTM(t,&ivalid);
		objtm = baseTM * objtm;
		invobjtm = Inverse(objtm);
		ObjectState sos;
		sos = targnode->EvalWorldState(t);
		ivalid &= sos.obj->ObjectValidity(t);


		if (sos.obj->IsSubClassOf(triObjectClassID))
			{
			meshSearchTree.SetNormalizeMesh(FALSE);
			meshSearchTree.SetDepth(quadDepth);



			TriObject *tobj = (TriObject*)sos.obj;
			Mesh &msh = tobj->GetMesh();

			meshSearchTree.BuildTree(&msh);
			}
		else if(sos.obj->CanConvertToType(triObjectClassID)) 
			{
			TriObject *tobj = (TriObject *)sos.obj->ConvertToType(t, triObjectClassID);
			meshSearchTree.SetNormalizeMesh(FALSE);
			meshSearchTree.SetDepth(quadDepth);



			Mesh &msh = tobj->GetMesh();

			meshSearchTree.BuildTree(&msh);
			tobjDelete = tobj;
			if (tobj != sos.obj) deleteMesh = TRUE;
			
			}

		if (inSolve) ivalid.Set(t,t);
		}
	else ivalid.Set(t,t);

	currentFrame = (t/GetTicksPerFrame())-startFrame;
	if (currentFrame < 0) currentFrame = 0;
	if (currentFrame >= frameData.Count()) currentFrame = frameData.Count()-1;
	//build  redir table
	if ( (inSolve) && (currentFrame >=0) && (currentFrame < frameData.Count()))
		{
		frameData[currentFrame]->frame = t;
//compute index list
		redirList.SetCount(os->obj->NumPoints());

		tempIndex.SetCount(os->obj->NumPoints());
		tempPoints.SetCount(os->obj->NumPoints());

		frameData[currentFrame]->index.ZeroCount();
		frameData[currentFrame]->points.ZeroCount();

		for (int i=0; i < redirList.Count(); i++)
			{
			redirList[i] = -1;
			tempIndex[i] = -1;
			}
		if (currentFrame > 0)
			{
			for (int i=0; i < frameData[currentFrame-1]->points.Count(); i++)
				{
				redirList[frameData[currentFrame-1]->index[i]] = i;
				}
						
			}
		}
	else
		{
		redirList.SetCount(os->obj->NumPoints());


		for (int i=0; i < redirList.Count(); i++)
			{
			redirList[i] = -1;
			}

		if ( (currentFrame >= 0) && (currentFrame < frameData.Count()))
			{
			for (int i=0; i < frameData[currentFrame]->points.Count(); i++)
				{
				redirList[frameData[currentFrame]->index[i]] = i;
				}
						
			}
		}

	ObjDeformer deformer(this);
	os->obj->Deform(&deformer, TRUE);

	if ((falloff  > 0.0f) && (!inSolve))
		{
		TriObject *baseTObj = (TriObject*)os->obj;
		Mesh &baseMesh = baseTObj->GetMesh();
//build adjacent list
		AdjEdgeList adjEdges(baseMesh);
//repeat until all verties are gone
		BOOL done = FALSE;


//int recurse_ct = 0;
		while (!done)
			{
			float smallestDist = FLT_MAX;
			BOOL noneProcessed = TRUE;
			for (int i=0; i < adjEdges.edges.Count(); i++)
				{
				int a,b;
//				if (adjEdges.edges[i].Visible(baseMesh.faces))
					{
					a = adjEdges.edges[i].v[0];
					b = adjEdges.edges[i].v[1];
					if (processList[a] && (!processList[b]))
						{
						float anchorDist = distList[a];
						float newDist = anchorDist + edgeDists[i];
						if (newDist < distList[b])
							{
							connectedTo[b] = a;
							distList[b] = newDist;
							if (newDist < smallestDist) smallestDist = newDist;
							noneProcessed = FALSE;
							}
						}
					else if (processList[b] && (!processList[a]))
						{
						float anchorDist = distList[b];
						float newDist = anchorDist + edgeDists[i];
						if  (newDist < distList[a])
							{
							connectedTo[a] = b;
							distList[a] = newDist;
							if (newDist < smallestDist) smallestDist = newDist;
							noneProcessed = FALSE;
							}
						}
					}
				}
//			recurse_ct++;
//DebugPrint("recurse d %d\n",recurse_ct);
			if ((smallestDist > falloff) || (noneProcessed) ) done = TRUE;
			for (i = 0; i < distList.Count(); i++)
				{
				if (distList[i] != FLT_MAX)
					{
//if we have not processed this vertex move it
					if (!processList[i])
						{
						int a = connectedTo[i];
						if (a >= 0)
							{
							float weight = 1.0f - distList[i]/falloff;
							weight = weight * weight * 0.6f;
							Point3 vec = vecList[a] * weight;
							baseMesh.verts[i] += vec;
							vecList[i] =  vec;
							}
						}
					processList.Set(i);
					}
				}

			}
		}

	os->obj->UpdateValidity(GEOM_CHAN_NUM,ivalid);	

	if (deleteMesh) tobjDelete->DeleteThis();
}


void ObjectDeform::BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev )
{
	this->ip = ip;
	ObjectDeformDesc.BeginEditParams(ip, this, flags, prev);
	objectdeform_param_blk.SetUserDlgProc(new ObjectDeformDlgProc(this));
}

void ObjectDeform::EndEditParams( IObjParam *ip, ULONG flags,Animatable *next)
{
	ObjectDeformDesc.EndEditParams(ip, this, flags, next);
	this->ip = NULL;
}



Interval ObjectDeform::GetValidity(TimeValue t)
{
	Interval valid = FOREVER;
	//TODO: Return the validity interval of the modifier
	return 	 ivalid;;
}




RefTargetHandle ObjectDeform::Clone(RemapDir& remap)
{
	ObjectDeform* newmod = new ObjectDeform();	
	//TODO: Add the cloning code here
	newmod->ReplaceReference(PBLOCK_REF,pblock->Clone(remap));
	BaseClone(this, newmod, remap);
	return(newmod);
}


//From ReferenceMaker 
RefResult ObjectDeform::NotifyRefChanged(
		Interval changeInt, RefTargetHandle hTarget,
		PartID& partID,  RefMessage message) 
{
	//TODO: Add code to handle the various reference changed messages
	return REF_SUCCEED;
}

/****************************************************************************************
*
 	NotifyInputChanged is called each time the input object is changed in some way
 	We can find out how it was changed by checking partID and message
*
\****************************************************************************************/

void ObjectDeform::NotifyInputChanged(Interval changeInt, PartID partID, RefMessage message, ModContext *mc)
{

}



//From Object
BOOL ObjectDeform::HasUVW() 
{ 
	//TODO: Return whether the object has UVW coordinates or not
	return TRUE; 
}

void ObjectDeform::SetGenUVW(BOOL sw) 
{  
	if (sw==HasUVW()) return;
	//TODO: Set the plugin internal value to sw				
}

#define FRAMECOUNT_CHUNK		0x2120
#define FRAME_CHUNK				0x2130
#define FRAMEDATACOUNT_CHUNK	0x2140
#define FRAMEDATAINDEX_CHUNK	0x2150
#define FRAMEDATAPOINT_CHUNK	0x2160

IOResult ObjectDeform::Load(ILoad *iload)
{
	//TODO: Add code to allow plugin to load its data
	Modifier::Load(iload);
//load cache	

	IOResult res = IO_OK;
	ULONG nb;



	Modifier::Load(iload);

	int ct = 0;
	int fct = 0;
	int frameDataCount = 0;
	int i;

	while (IO_OK==(res=iload->OpenChunk())) {
		switch(iload->CurChunkID())  {
			case FRAMECOUNT_CHUNK:
				iload->Read(&ct,sizeof(int), &nb);
				frameData.SetCount(ct);
				for (i =0; i < ct; i++)
					{
					frameData[i] = new FrameList();
					}
				break;
			case FRAME_CHUNK:
				{
				int frame;
				iload->Read(&frame,sizeof(int), &nb);
				frameData[fct]->frame = frame;
				break;
				}
			case FRAMEDATACOUNT_CHUNK:
				iload->Read(&frameDataCount,sizeof(int), &nb);
				frameData[fct]->index.SetCount(frameDataCount);
				frameData[fct]->points.SetCount(frameDataCount);
				if (frameDataCount == 0) fct++;
				break;
			case FRAMEDATAINDEX_CHUNK:
				iload->Read(frameData[fct]->index.Addr(0),sizeof(int)*frameDataCount, &nb);
				break;
			case FRAMEDATAPOINT_CHUNK:
				iload->Read(frameData[fct]->points.Addr(0),sizeof(Point3)*frameDataCount, &nb);
				fct++;
				break;


			}


		iload->CloseChunk();
		if (res!=IO_OK)
			return res;
		

		}

	return IO_OK;
}

IOResult ObjectDeform::Save(ISave *isave)
{
	//TODO: Add code to allow plugin to save its data
	Modifier::Save(isave);	
//save cache
	ULONG nb; 
//count
	int fct = frameData.Count();
	isave->BeginChunk(FRAMECOUNT_CHUNK);
	isave->Write(&fct,sizeof(int),&nb);
	isave->EndChunk();

//frame
	for (int i=0; i <fct; i++)
		{
		int frame = frameData[i]->frame;
//frame count
		isave->BeginChunk(FRAME_CHUNK);
		isave->Write(&frame,sizeof(int),&nb);
		isave->EndChunk();

		int ct = frameData[i]->index.Count();
		isave->BeginChunk(FRAMEDATACOUNT_CHUNK);
		isave->Write(&ct,sizeof(int),&nb);
		isave->EndChunk();

		if (ct != 0)
			{
//index list
			isave->BeginChunk(FRAMEDATAINDEX_CHUNK);
			isave->Write(frameData[i]->index.Addr(0),sizeof(int)*ct,&nb);
			isave->EndChunk();
//point list	
				isave->BeginChunk(FRAMEDATAPOINT_CHUNK);
			isave->Write(frameData[i]->points.Addr(0),sizeof(Point3)*ct,&nb);
			isave->EndChunk();
			}
		}
	return IO_OK;
}

void ObjectDeform::SolveFrames()
{
	
	TimeValue tpf = GetTicksPerFrame();
//get start frame
//	TimeValue endFrame, startFrame;

	int sf,ef;
	sf = startFrame * tpf;
	ef = endFrame *tpf;

/*
	for (int i=0; i < frameData.Count(); i++)
		{
		FrameList *t = frameData[i];
		if (t) delete t;
		}
	frameData.ZeroCount();
*/
//	frameData.SetCount(endFrame-startFrame+1);
//get duration
//loop through frames and solve
	int ct = 0;
	for (int i = startFrame; i <= endFrame; i++)
		{
		if (i >= frameData.Count())
			{
			FrameList *t = new FrameList();
			frameData.Append(1,&t);
			}
		}

    MyEnumProc dep;              
	EnumDependents(&dep);
	INode *node = dep.Nodes[0];

	if (GetCOREInterface()->GetTime() == sf)
		{
		node->EvalWorldState(sf+tpf);
		}	

	inSolve = TRUE;

	TSTR name;


	for (i = startFrame; i <= endFrame; i++)
		{

		node->EvalWorldState(sf);

		for (int j=0; j < tempIndex.Count(); j++)
			{
			int id = tempIndex[j];
			Point3 vec = tempPoints[j];
			if (id != -1)
				{
				frameData[currentFrame]->index.Append(1,&id);
				frameData[currentFrame]->points.Append(1,&vec);
				}
			}

		name.printf("Frame %d",sf/tpf);
		SetWindowText(GetDlgItem(rolluphWnd,IDC_STATUS),name);

		SHORT iret = GetAsyncKeyState (VK_ESCAPE);
		if (iret==-32767)
			{
			i = endFrame+1;
			}


		sf += tpf;
		}

	inSolve = FALSE;

	DisplayCacheMem();

}


void ObjectDeform::DisplayCacheMem()
{
	ULONG s = CacheSize();

	s = s*sizeof(int) *2 + s*sizeof(Point3);
	
	float bytes = (float)s / 1000000.0f;

	TSTR name;
	name.printf("Cache %0.2f Megs",bytes);
	SetWindowText(GetDlgItem(rolluphWnd,IDC_STATUS),name);
	NotifyDependents(FOREVER, GEOM_CHANNEL, REFMSG_CHANGE);
}

void ObjectDeform::ClearCache()
{
	for (int i = 0; i < frameData.Count(); i++)
		{
		FrameList *t = frameData[i];
		if (t) delete t;
		}
	frameData.ZeroCount();

	TSTR name;
	name.printf("No Cache Present");
	SetWindowText(GetDlgItem(rolluphWnd,IDC_STATUS),name);
	NotifyDependents(FOREVER, GEOM_CHANNEL, REFMSG_CHANGE);
}

int ObjectDeform::CacheSize()
{
	int ct = 0;
	for (int i = 0; i < frameData.Count(); i++)
		{
		if (frameData[i])
			ct += frameData[i]->index.Count();
		}
	return ct;
}
